// *************************************************************************
//    PNode.h - A Parse Node
// *************************************************************************

#ifndef _PNode_H_
#define _PNode_H_

// *************************************************************************

class Cor_CArg;
class Cor_CArgStack;

// *************************************************************************

#define    NUM_LITERAL     6        // The number of literals needed
#define    NUM_CHILDREN    4        // The number of child nodes

    // The PNode Kind
enum Cor_PNodeKind {

    PN_NONE=0,

    PN_LITERAL,           // A simple literal
    PN_LITERLIST,         // A list of literals

    PN_ITEMLIST,          // A list of anything (each ends with a period)

    PN_MODULE,            // A module
    PN_C_MODULE,          // A C module
    PN_END_MODULE,        // The end of a module (either type)

    PN_ANNOTATION,        // An annotation

    PN_EXPRT_STEMNT,      // An export statement
    PN_EXPRT_ITEM,        // An exported item

    PN_RULE,              // A rule      ":-"
    PN_ASSIGN,            // Assignment  ":="
    PN_DELETE,            // Delete      "-="
    PN_APPEND,            // Append      "+="
};


    // A PNode modifier
enum Cor_PNodeMod {

    PNM_NONE=0,     // No modifier
    PNM_NEGATED,    // negated
    PNM_DEL,        // marked as 'del'
    PNM_PLUS,       // "on"
    PNM_MINUS       // "off"
}

// *************************************************************************

class Cor_PNode {

  private:
    Cor_PNodeKind   kind;    // The type of node this is

        // Info, may be filled in depending on kind, otherwise it is NULL
    Cor_CArg       *literal[NUM_LITERAL];

    Cor_CArgStack  *arg_list;

    Cor_PNodeMod    modify;

                             // Children (interpret depending on kind)
    Cor_PNode       *child[NUM_CHILDREN]; 

  public:
    Cor_PNode(Cor_PNodeKind kind=PN_NONE);
   ~Cor_PNode();
}


// *************************************************************************

#endif _PNode_H_

