// *************************************************************************
//    QueryStack.h
// *************************************************************************

#ifndef _QueryStack_H_
#define _QueryStack_H_

#include <iostream.h>
#include <stdlib.h>

class Cor_ArgList;

// *************************************************************************

class Cor_QueryInfo {
  public:
    Cor_ArgList    *query;
    int             qid;
};

class Cor_QueryStack {

  private:
    Cor_QueryInfo **data;
    int             length;
    int             data_size;

  public:
    Cor_QueryStack() {
                     data = NULL;
                     length = 0;
                     data_size = 0;
                   }
    Cor_QueryStack(int sze) {
                            data = new Cor_QueryInfo* [sze];
                            length = 0;
                            data_size = sze;
                          }

   ~Cor_QueryStack() { delete [] data; }

    int  count() { return(length); }
    int  is_empty() { return(length == 0); }

      // push() returns the position
    int  push(Cor_QueryInfo *item);

    Cor_QueryInfo *get_ith(int i) {
        if (i < length)
            return(data[i]);
        return(NULL);
    }

    void set_ith(int i, Cor_QueryInfo *val) {
        if (i < length)
            data[i] = val;
    }

      // Delete an element based on its position, this function must
      // maintain the "stack" concept, sliding the other values down.
    void del_ith(int i) {
        for (; i < length-1; i++) 
            data[i] = data[i+1];
        length--;
    }

        // Pull out the last element
    Cor_QueryInfo *pop() {
        if (length > 0) {
            length--;
            return(data[length]);
        } else {
            return(NULL);
        }
    }

        // Peek at the last element
    Cor_QueryInfo *top() {
        if (length > 0)
            return(data[length-1]);
        return(NULL);
    }

      // Empty out the stack
    void empty() {
        // Warning! drops all the pointers
        length = 0;
    }

    int contains(Cor_QueryInfo *elemnt) {
        for (int j=0; j < length; j++)
            if (data[j] == elemnt)
                return(1);
        return(0);
    }

/*
      // Delete an element based on its value, this function must
      // maintain the "stack" concept, sliding the other values down.
      // The return value indicates if the value was found.      
    int  del_val(Cor_QueryInfo *val) {
        int did_it = 0;

        for (int j=0; j < length; j++)
            if (data[j] == val) {
                did_it = 1;
                for (; j < length-1; j++)
                    data[j] = data[j+1];
                length--;
                break;
            } 

        return(did_it);
    }
*/

      // Stream printing
    friend ostream& operator<< (ostream& out, const Cor_QueryStack& qlist);
};

// *************************************************************************

#endif _QueryStack_H_
