// *************************************************************************
//    Sips.h
// *************************************************************************

#ifndef _Sips_H_
#define _Sips_H_

// *************************************************************************
// Sideways instruction passing strategy representation

class Cor_Sip;
class Cor_Sips;

class Cor_Sips {
  public:
    Cor_BitVector  adorn;
    Cor_Sip       *sip_list;
    Cor_Sips      *next;
};

// *************************************************************************

class Cor_Sip {
  public:
    Cor_BitVector tail;        // BitVector of indexes into rhs preds[] 
    int           head;        // 0 if head, else index into rhs preds[]+1 
    Cor_BitVector bound_vars;  // Bits that are set are used to 
                               // index into var_names[] 
    Cor_Sip      *next;
};

// *************************************************************************

#define numpredsinsip(s)     (s)->count()
#define firstpredinsip(s)    (s)->next(-1)
#define nextpredinsip(s,p)   (s)->next(p)

// *************************************************************************

#endif _Sips_H_
