// *************************************************************************
//    Table.h
// *************************************************************************

#ifndef _Table_H_
#define _Table_H_

#include "RelationStruct.h"
#include "ModuleEnv.h"
#include "Context.h"
//#include "QFModuleData.h"
#include "Debug.h"

// *************************************************************************

class Cor_QFModuleData;

// *************************************************************************

class Cor_Table {

  public:
    int numRels;
    Cor_RelationStruct *rels;

    Cor_ModuleEnv *module_env;   // dynamic data structures used
                                 // for module execution

    int interrupt_flag;          // used by cut and single answer to interrupt
                                 // execution of the current module  

    Cor_Context      *context;     // the stack for ordered search
    Cor_QFModuleData *moduledata;  // data about module 

    Cor_Table        *next;        // Keeps a list of free initialized table
                                   // structs that can be reused.

    Cor_Table(int num_rels) {
        rels    = new Cor_RelationStruct[num_rels];
        numRels = num_rels;
        context = NULL;
        module_env = NULL;
        moduledata = NULL;
        next = NULL;
    }

    Cor_Table(Cor_QFModuleData *md);
   ~Cor_Table();

    void AddValue(int i, Cor_CArg& relName, int arity);
};

// *************************************************************************

#endif _Table_H_

