# jtextvi.tcl - additional procedures for vi-like Text bindings
# 
# Copyright 1992-1994 by Jay Sekora.  All rights reserved, except 
# that this file may be freely redistributed in whole or in part 
# for nonprofit, noncommercial use.
# 
# 
# Essentially, call
#   j:tb:basic_bind Text    ---   for basic Text bindings
#   j:tb:emacs_bind Text    ---   for Emacs-like Text bindings
#   j:tb:vi_bind Text       ---   for vi-like Text bindings
# (the emacs_bind and vi_bind procedures include the basic_bind 
# procedures; you don't have to call both.)
# You can check $j_tb(modified,$WIDGET) to see if a text widget has been
# modified.  (Set it to false when you save the text widget.)

# TO DO:
# ^L
# sentence-manipulation stuff
# case change commands, transposition commands
# commands to do with mark?
# word deletion - fix to use buffer
# generalise movement to copying-to-cutbuffer and deletion
# IMPROVE ENTRY BINDINGS
# literal-insert for entry


proc j:tkb:vi:command { W K A } {
  j:tkb:left $W "" ""
  j:tkb:new_mode vi-command $W $K $A
}

proc j:tkb:vi:insert { W K A } {
  j:tkb:new_mode vi-insert $W $K $A
}

proc j:tkb:vi:newline { W K A } {
  global j_teb
  j:tkb:down $W $K $A
  j:tkb:bol $W $K $A
}

proc j:tkb:vi:append { W K A } {
  global j_teb
  # BOGUS - crosses newline boundaries
  j:tkb:right $W $K $A
  j:tkb:vi:insert $W $K $A
}

proc j:tkb:vi:insert-bol { W K A } {
  global j_teb
  # BOGUS - bgg of line, not bgg of printable line
  j:tkb:bol $W $K $A
  j:tkb:vi:insert $W $K $A
}

proc j:tkb:vi:append-eol { W K A } {
  global j_teb
  # BOGUS - end of line, not end of printable line
  j:tkb:eol $W $K $A
  j:tkb:vi:insert $W $K $A
}

