%
% Test sets and nesting them.
%
clear(interactive_mode).
set(insert_mode).

% We start out easy
my_f1({a,b,2}).
?my_f1(A).

% Now a little nesting
my_f2( {2,{3,{4,{5,k,5.2},6.2},7.2},8.2} ).  
my_f2( {{{{1}}}} ).  
my_f2( {0,{{2}}} ).  
my_f2( {{}} ).  
?my_f2(B).

% Try a few builtin set operations
?member({9,6,3,0}, B2).
?add_elem(3,{1,2,4},C).
?unionsum({1,4,6}, {2,4,8}, D).
?unionmax({1,4,6}, {2,4,8}, E).
?unionmax({}, {}, F).
?inter({1,4,6}, {2,4,8}, G).
?inter({1,3,6}, {2,4,8}, H).
?difference({1,4,6}, {2,4,8}, I).
?difference({2,4,8}, {2,4,8}, J).

?make_set({5,2,5,1,0,2,4}, K).
% try the destructive version
? Z = {5,2,5,1,0,2,4}, make_set_d(Z), print(Z), printf("\n").

?avg({3,1,2,4},L).
?count({3,1,2,4},M).
?sum({3,1,2,4},N).
?min({3,1,2,4},P).
?max({3,1,2,4},R).

?subset({1,3}, {1,2,3}), printf("{1,3} is a subset of {1,2,3}.\n").
?subset({}, {1,2,3}), printf("{} is a subset of {1,2,3}.\n").
?subset({1,2,4}, {1,2,3}), printf("{1,2,4} is a subset of {1,2,3}.\n").


% These should fail
?is_functor( {1,2,3} ), printf("{1,2,3} is a functor.\n").
?is_string( {1,2,3} ), printf("{1,2,3} is a string.\n").
?is_list( {} ), printf("{} is a list.\n").
? {} = nil, printf("{} = nil.\n").

quit.
