
module extens_eg4.
export input_array(bbf).

% This predicate allows for convenient creation of a 
% logical array value from data presented as a relation.  
% By changing the logical_array literal to an array
% literal, we can create destructive arrays.

input_array(In_rel, Size, NewArray) :- 
	logical_array(NewArray,Size), member(In_rel,I,V), bind(NewArray,I,V).


end_module.

% Given the following facts, the goal 
% ?input_array(input,5,A) creates a new 
% array A that contains the elements a--e.

input(0,a).
input(1,b).
input(2,c).
input(3,d).
input(4,e).

