// *************************************************************************
//    ModuleInfo.C
// *************************************************************************

#include "ModuleInfo.h"
#include "ExportInfo.h"

#include "Globals.h"
#include "Debug.h"

// *************************************************************************
Cor_ModuleInfo::~Cor_ModuleInfo()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    clear();
}

// *************************************************************************
void Cor_ModuleInfo::init_flags()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    PreProcessing = Cor_exEnv->C_preprocessing_default;
    Rewriting = Cor_exEnv->C_rewriting_default;
    UseSupplementaryMagic = Cor_exEnv->C_use_supplementary_magic_default;
    UseMagic = Cor_exEnv->C_use_magic_default;
    CheckSubsum = Cor_exEnv->C_check_subsum_default;
    MultiSet = Cor_exEnv->C_multisets_default;
    IndexDeltas = Cor_exEnv->C_index_deltas_default;
    UseFactorMagic = Cor_exEnv->C_use_factor_magic_default;
    UsePipelining = Cor_exEnv->C_use_pipelining_default;
    UseOrdSearch = Cor_exEnv->C_use_ordsearch_default;
    LazyEval = Cor_exEnv->C_use_lazy_eval_default;
    Monotonic = Cor_exEnv->C_use_monotonic_default;
    UseFactoring = Cor_exEnv->C_use_factoring_default;
    DiskRel = Cor_exEnv->C_diskrel_default;
    NaiveBacktrack = Cor_exEnv->C_naive_bcktrking_default;
    NestedSccEval = Cor_exEnv->C_nested_scc_eval_default;

    SingleScc = Cor_exEnv->C_single_scc_default;
    SingleAnswer = Cor_exEnv->C_single_answer_default;
    ConvertFunctions = Cor_exEnv->C_convert_functions_default;
}

// *************************************************************************
void Cor_ModuleInfo::init()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    ExportedPreds = NULL;
    ExportedCount = 0;
    init_flags();
}

// *************************************************************************
void Cor_ModuleInfo::clear()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    Cor_ExportInfo *curr, *prev = NULL;

    for (curr = ExportedPreds; curr; curr = curr->next) {
        delete prev;
        prev = curr;
    }

    delete prev;

    ExportedPreds = NULL;
}

// *************************************************************************
