// *************************************************************************
//    Context.h
// *************************************************************************

#ifndef _Context_H_
#define _Context_H_

#include "ContextNode.h"
#include "GoalNode.h"
#include "Debug.h"

// *************************************************************************
//    Codependent classes

class Cor_ContextNode;

// *************************************************************************

class Cor_Context {

  public:
    Cor_ContextNode *first;
    Cor_ContextNode *last;
    Cor_ContextNode *first_marked;
    Cor_ContextNode *last_marked;

    Cor_ContextNode *all_nodes;     // For memory cleanup - SPF

    Cor_Context();
   ~Cor_Context();

    void add_new_goal(Cor_GoalNode *g_node, Cor_GoalNode *par);
    void insert_last(Cor_ContextNode *c_node);
    void insert_before(Cor_ContextNode *c_node,
            Cor_ContextNode *par_next_c_node);

    void delete_goal(Cor_GoalNode *g);
    void unlink_node(Cor_ContextNode *g_c_node);

    Cor_GoalNode *get_unmarked_goal(int &any_new_fact_in_done);
    void update_marked_info(Cor_ContextNode *c_node);

    void collapse_nodes(Cor_GoalNode *from,
                Cor_GoalNode *par, Cor_GoalNode *to);
    void print_all(ostream *file);
    void free_all();
};

// *************************************************************************

#endif _Context_H_
