// *************************************************************************
//    RMarkArray.C
// *************************************************************************

#include "RMarkArray.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************
//  Constructor for RMarkArray. All RMarks * are initially NULL.
//  Even RMarks are 'old' and odd RMarks are 'new'.
//  Size should be even !!
// *************************************************************************

Cor_RMarkArray::Cor_RMarkArray(int size)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    markList = new Cor_RMark*[size];
    for (int i = 0; i< size; i++) {
        markList[i] = NULL;
    }
    array_size = size;
}

// *************************************************************************
/*
    Copies a new RMark at position i+1 to the old RMark at position i.
    Obviously, i should be even.
*/

void Cor_RMarkArray::New_To_Old(int i)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (i < array_size - 1) {
        markList[i] = markList[i+1];
        markList[i+1] = NULL;
    }
}

// *************************************************************************
Cor_RMarkArray::~Cor_RMarkArray()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    delete [] markList;
}

// *************************************************************************
