// *************************************************************************
//    Table.C
// *************************************************************************

#include "Table.h"
#include "QFModuleData.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************
void Cor_Table::AddValue(int i, Cor_CArg& relName, int arity)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    rels[i].AssignVal(relName, arity);
}

// *************************************************************************
Cor_Table::Cor_Table(Cor_QFModuleData *md)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    Cor_Table *F = md->F;

    numRels = F->numRels;
    rels = new Cor_RelationStruct[numRels];

    for (int j = 0; j < numRels; j++)
        rels[j].AssignVal(F->rels[j].relName, F->rels[j].relArity);

    next = NULL;
    context = NULL;
    moduledata = md;

    module_env = new Cor_ModuleEnv((Cor_QFMaterializedModuleData *)md);
}

// *************************************************************************
Cor_Table::~Cor_Table()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    delete [] rels;
    delete module_env;

    delete context;
}

// *************************************************************************
