#ifndef  _SUSPEND_H_
#define  _SUSPEND_H_

// *************************************************************************
// Suspend.h
//
// all the local variable originally in SemiNaive::evaluate
// the class defined is a context for the evaluation function so that
// the later can be resumed later.
// *************************************************************************


class Cor_SuspendContext {

  public:
    Cor_Table          *table;
    Cor_SemiNaive      *semi_naive;
    Cor_CArg           *curr_ws_name;  // name for current workspace

    Cor_Trail          *trail;         // stack
  
    short               conn_id;   // Connection this query was suspended from
    short               user_id;   // Who suspended this query
    int                 answer;    // How many answers to give at once
  
    short               current;
    short               backtrack_index; 
    unsigned int        answer_count;

    Cor_TupleIterator **tuple_its;
    Cor_StackMark       stackmark0;
    Cor_Tuple         **tuples;
    Cor_RuleEnv        *rule_env;
    char                direction;

      // Make a new duplicate of this context
    Cor_SuspendContext *dup() {

        Cor_SuspendContext *that = new Cor_SuspendContext();

        that->table = table;
        that->semi_naive = semi_naive;
        that->curr_ws_name = curr_ws_name;
        that->trail = trail;

        that->conn_id = conn_id;
        that->user_id = user_id;
        that->answer = answer;

        that->current = current;
        that->backtrack_index = backtrack_index;
        that->answer_count = answer_count;

        that->tuple_its = tuple_its;
        that->stackmark0 = stackmark0;
        that->tuples = tuples;
        that->rule_env = rule_env;

        that->direction = direction;

        return(that);
    }
};

#endif
